theory BD_Security imports "../Preliminaries/Trivia"
begin

no_notation relcomp (infixr "O" 75)

locale BD_Security = 
 fixes 
  validSystemTrace :: "'traces \<Rightarrow> bool"
and
  V :: "'traces \<Rightarrow> 'values"
and 
  O :: "'traces \<Rightarrow> 'observations"
and (* declassification bound: *)
  B :: "'values \<Rightarrow> 'values \<Rightarrow> bool"
and (* declassification trigger: *)
  TT :: "'traces \<Rightarrow> bool"
begin 

(* BD security: *)
definition secure :: bool where
"secure \<equiv>
 \<forall> tr vl vl1.
   validSystemTrace tr \<and> TT tr \<and> B vl vl1 \<and> V tr = vl \<longrightarrow>
   (\<exists> tr1. validSystemTrace tr1 \<and> O tr1 = O tr \<and> V tr1 = vl1)"

lemma secureE:
assumes "secure" and "validSystemTrace tr" and "TT tr" and "B (V tr) vl1"
obtains tr1 where "validSystemTrace tr1" "O tr1 = O tr" "V tr1 = vl1"
using assms unfolding secure_def by auto

end (* context BD_Security *)


end