theory Transitions
imports "../Preliminaries/Trivia"
begin

(* Design decision: transitions, hence traces, include the states too.
This is convenient for manipulating invariants. *)
(* transition: *)
datatype ('state,'act,'out) trans = Trans 'state 'act 'out 'state

fun srcOf where "srcOf (Trans s a ou s') = s" (* source of *)
fun actOf where "actOf (Trans s a ou s') = a"
fun outOf where "outOf (Trans s a ou s') = ou"
fun tgtOf where "tgtOf (Trans s a ou s') = s'" (* target of *)

(* system trace: *)
type_synonym ('state,'act,'out) trace =
   "('state,'act,'out) trans list"

fun srcOftr where "srcOftr tr = srcOf(hd tr)" (* source of *)
fun tgtOftr where "tgtOftr tr = tgtOf(last tr)" (* target of *)


end 